-- PT3Bar
local bf = LibStub("AceAddon-3.0"):GetAddon("ButtonFacade")
local lbf = LibStub("LibButtonFacade")
local pt3barbf = bf:NewModule("PT3Bar"); AceLibrary("AceEvent-2.0"):embed(pt3barbf)

local defaults = {
	profile = {
		["*"] = {
			Skin = "Blizzard",
			Gloss = 0,
			Backdrop = false,
		},
	},
}

function pt3barbf:OnInitialize()
	self.db = self:RegisterNamespace("PT3Bar", defaults)
	self:RegisterEvent("Ace2_AddonEnabled")
end

function pt3barbf:SkinCallback(skin, gloss, backdrop, group)
	if not group then return end
	self.db.profile[group].Skin = skin
	self.db.profile[group].Gloss = gloss
	self.db.profile[group].Backdrop = backdrop
end

function pt3barbf:SetupGroup(group, frameprefix, count)
	local bargroup = lbf:Group("PT3Bar", group)
	for i=1, count, 1 do
		local button = _G[frameprefix..i]
		if button then
			for k=1,20 do
				local popupbutton = _G[frameprefix..i.."Popup"..k]
				if popupbutton then
					bargroup:AddButton(popupbutton)
				end
			end
			bargroup:AddButton(button)
		end
	end
	bargroup:Skin(self.db.profile[group].Skin, self.db.profile[group].Gloss,
	              self.db.profile[group].Backdrop)
end

function pt3barbf:Load()
	self:SetupGroup("ActionBar", "PT3Bar", 20)
	lbf:RegisterSkinCallback("PT3Bar", self.SkinCallback, self)
end

function pt3barbf:Ace2_AddonEnabled(addon)
	if addon.name == "PT3Bar" then
		pt3barbf:Load()
		self:UnregisterEvent("Ace2_AddonEnabled")
	end
end